/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package at.fhooe.mc.magicwand.client.controller;

import at.fhooe.mc.magicwand.client.request.*;
import at.fhooe.mc.magicwand.client.network.*;
/**
 *
 * @author Maria
 */
public class Controller {

    private RequestCreator m_creator;
    private String m_responseXml;
    private ClientServerConnection m_connection;
    private boolean m_successfulResponse;

    public Controller(){
        //TODO
        //Socket zum Server starten
        m_connection = new ClientServerConnection(4444);
        m_creator = new RequestCreator();
        m_responseXml = new String();
        m_successfulResponse = false;
    }

    /**
     * @fn public void makeRequest(String maxDistance, String distanceOption)
     * @brief Uses the RequestCreator class to make a new request, send it to the
     * server and get the response xml.
     * @param _maxDistance maximum distance set in the options screen
     * @param _accuracy accuracy option set in the options screen
     */
    public void makeRequest(String _maxDistance, String _accuracy){
        m_successfulResponse = false;
        String requestMessage = m_creator.createRequest(_maxDistance,_accuracy);
        m_responseXml = m_connection.sendAndReceive(requestMessage);
        m_successfulResponse = (m_responseXml != null);
        //TODO
        //response is null if exception occured, check when parsing
    }

    public boolean isRequestSuccessful(){
        return m_successfulResponse;
    }

    public void exitConnection(){
        //TODO
        //close Symbianserver

        m_connection.closeConnection();
    }

    public void setOptions(String[] _options) {
    }
}

